﻿using System.Threading.Tasks;
using System.Windows.Forms;
using System;
using NTERA;
using NTERA.Console;
using NTERA.Core;
using NTERA.EmuEra;
using NTERA.Engine;
using NTERA.Engine.Runtime;

namespace NTERA
{
	public partial class formMain : Form
	{
		private readonly GameInstance instance = new GameInstance();

		public formMain(Options options)
		{
			InitializeComponent();

            //var scriptEngine = new EmuEraGameInstance();
            //var scriptEngine = new Engine();
			var scriptEngine = new EraRuntime(new JITCompiler(options.EraFolder), options.IgnoreErrors);

            //Task.Factory.StartNew(() => instance.Run(new EraConsoleInstance(consoleControl1.Renderer, scriptEngine), scriptEngine));
            Task.Factory.StartNew(() => instance.Run(new EraConsoleInstance(consoleControl1.Renderer, scriptEngine), scriptEngine));
		}

		private void txtInput_KeyDown(object sender, KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Enter)
			{
				instance.GiveInput(txtInput.Text);
				txtInput.Text = "";

				e.Handled = true;
				e.SuppressKeyPress = true;
			}
		}
	}
}